"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var IcrcHelper;
(function (IcrcHelper) {
    var Countries = {
        Somalia: 'Somalia',
        Ethiopia: 'Ethiopia'
    };
    var Common = /** @class */ (function () {
        function Common() {
        }
        Common.setSectionVisible = function (elementId, isVisible) {
            var obj = $("table[data-name='" + elementId + "']").closest('fieldset');
            if (isVisible) {
                obj.show();
            }
            else {
                obj.hide();
            }
        };
        Common.generateHTMLErrorModal = function (dockerTag, modalId, errorMessage, title) {
            if (title === void 0) { title = undefined; }
            title = title !== null && title !== void 0 ? title : "Error";
            var modal = "<div id=\"" + modalId + "\" class=\"modal fade\" role=\"dialog\">\n                          <div class=\"modal-dialog\">\n                            <div class=\"modal-content\">\n                                <div class=\"modal-header\">\n                                    <button aria-label=\"Close\" class=\"form-close\" data-dismiss=\"modal\" tabindex=\"0\" title=\"Close\" type=\"button\">\n                                        <span aria-hidden=\"true\">x</span>\n                                        <span class=\"sr-only\">Close</span>\n                                    </button>\n                                    <h1 class=\"modal-title\" title=\"" + title + "\">" + title + "</h1>\n                                </div>\n                                <div class=\"modal-body\">" + errorMessage + "</div>\n                                <div class=\"modal-footer\">\n                                    <button aria-label=\"Close\" class=\"cancel btn btn-default\" data-dismiss=\"modal\" tabindex=\"0\" title=\"Close\" type=\"button\">Close</button>\n                                </div>\n                            </div>\n                          </div>\n                        </div>";
            if (!$("#" + modalId).length) {
                $("" + dockerTag).append(modal);
            }
        };
        Common.generateHTMLConfirmationModal = function (dockerTag, modalId, errorMessage, title) {
            if (title === void 0) { title = undefined; }
            title = title !== null && title !== void 0 ? title : "Error";
            var modal = `<div id="${modalId}" class="modal fade" role="dialog">
                            <div class="modal-dialog modal-lg">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <button aria-label="Close" class="form-close" data-dismiss="modal" tabindex="0" title="Close" type="button">
                                            <span aria-hidden="true">×</span>                                       
                                            <span class="sr-only">Close</span>
                                        </button>                               
                                    </div>
                                    <div class="modal-body">
                                        <h5>${title}</h5> 
                                        <p>${errorMessage}</p>
                                    </div>
                                    <div class="modal-footer">
                                        <button onclick="$('#NextButton').click()" aria-label="Submit" data-dismiss="modal" class="btn btn-primary" title="YES, SUBMIT MY REQUEST" type="button">YES, SUBMIT MY REQUEST</button>
                                        <button aria-label="Close" class="cancel btn btn-default" data-dismiss="modal" tabindex="0" title="Close" type="button">NO, GO BACK</button>
                                    </div>
                                </div>
                            </div>
                        </div>`;
            if (!$("#" + modalId).length) {
                $("" + dockerTag).append(modal);
            }
        };
        Common.generateHTMLWarningModal = function (dockerTag, modalId, errorMessage, title, image) {
            if (title === void 0) { title = undefined; }
            title = title !== null && title !== void 0 ? title : "Warning";
            var modal = `<div id="${modalId}" class="modal fade" role="dialog">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <button aria-label="Close" class="form-close" data-dismiss="modal" tabindex="0" title="Close" type="button">
                                            <span aria-hidden="true">×</span>                                       
                                            <span class="sr-only">Close</span>
                                        </button>                               
                                    </div>
                                    <div class="modal-body" style="padding: 15px">
                                        <div class="text-center">
                                            ${image != null ? `<img src="/${image}" alt="Form difficulties" />` : ''}
                                        </div>
                                        <p id="warningMessageModal-description">${errorMessage}</p>
                                    </div>
                                    <div class="modal-footer">
                                        <button id="warningMessageModal-button" style="width: 100%" aria-label="Close" data-dismiss="modal" class="btn btn-primary" title="I UNDERSTAND" type="button">I UNDERSTAND</button>
                                    </div>
                                </div>
                            </div>
                        </div>`;
            if (!$("#" + modalId).length) {
                $("" + dockerTag).append(modal);
            }
        };
        Common.sortOptions = function (elementId) {
            var sel = $('select#' + elementId);
            var selected = sel.val(); // cache selected value, before reordering
            var opts_list = sel.find('option');
            opts_list.toArray().sort(function (a, b) {
                return $(a).text() > $(b).text() ? 1 : -1;
            });
            sel.html('').append(opts_list);
            sel.val(selected); // set cached selected value
        };
        Common.waitForElement = function (selector) {
            return new Promise(function (resolve) {
                if (document.querySelector(selector)) {
                    return resolve(document.querySelector(selector));
                }
                var observer = new MutationObserver(function (mutations) {
                    if (document.querySelector(selector)) {
                        resolve(document.querySelector(selector));
                        observer.disconnect();
                    }
                });
                observer.observe(document.body, {
                    childList: true,
                    subtree: true
                });
            });
        };
        Common.findLeafNodesWithText = function (node, text){
            if (node.nodeType === Node.TEXT_NODE && node.textContent.includes(text)) {
                return [node.parentNode];
            }
        
            if (node.nodeName === 'SCRIPT') {
                return [];
            }
            var leafNodes = [];
            for (var i = 0; i < node.childNodes.length; i++) {
                var child = node.childNodes[i];
                leafNodes = leafNodes.concat(IcrcHelper.Common.findLeafNodesWithText(child, text));
            }
            return leafNodes;
        }
        Common.translateElements = function (language, soughtPersonName){
            webapi.safeAjax({
                type: "GET",
                url: `/_api/core_otrportaltranslations?$select=core_language,core_translationsobject&$filter=(core_language eq '${language}' and statecode eq 0)`,
                contentType: "application/json",
                headers: {
                    "Prefer": "odata.include-annotations=*"
                },
                success: function (data, textStatus, xhr) {
                    const results = data.value;
                    const optionSelectors = [
                        'core_familystatuscode', 
                        'core_soughtpersonmaritalstatuscode', 
                        'core_portalrelationshipbtwreqandsoughtper',
                        'core_portalrelationshiptosoughtperson', 
                        'core_nationalityid', 
                        'core_countryofbirthid', 
                        'core_portalcountry', 
                        'core_soughtpersonnationality', 
                        'core_soughtpersoncountryofbirth', 
                        'core_soughtpersoncountry', 
                        'core_portalnationalityid', 
                        'core_portalcountryofbirth', 
                        'core_countryoflastnews'
                    ];
        
                    results.forEach(result => {
                        const jsonObject = JSON.parse(result.core_translationsobject);
        
                        Object.entries(jsonObject).forEach(([key, value]) => {
                            if (!value) return;
        
                            let keyValue, keyNumber, optionSetInput, videoIframe;
        
                            if (key.includes('code_option')) {
                                keyValue = key.split('_')[3];
                                if (keyValue) {
                                    optionSetInput = key.includes('core_typeoflastnews') 
                                        ? key.split('code_option')[0]
                                        : key.split('_option')[0];
                                    $(`#${optionSetInput} option[value="${keyValue}"]`).text(value);
                                }
                            } else if (key.includes('core_familyandmaritalstatus_option')) {
                                keyValue = key.split('_')[3];
                                if (keyValue) {
                                    optionSelectors.slice(0, 2).forEach(selector => {
                                        $(`#${selector} option[value="${keyValue}"]`).text(value);
                                    });
                                }
                            } else if (key.includes('core_portalrelationshipbtwreqandsoughtper_option')) {
                                keyValue = key.split('_')[3];
                                if (keyValue) {
                                    optionSelectors.slice(2, 4).forEach(selector => {
                                        $(`#${selector} option[value="${keyValue}"]`).text(value);
                                    });
                                }
                            } else if (key.includes('option_core_gendercode')) {
                                keyValue = key.split('option_')[1];
                                keyNumber = key.split('_')[3];
                                if (keyValue) {
                                    [`label[for="${keyValue}"]`, 
                                     `label[for="core_soughtpersongender_${keyNumber}"]`, 
                                     `label[for="core_portalgender_${keyNumber}"]`]
                                    .forEach(selector => {
                                        $(selector).text(value);
                                    });
                                }
                            } else if (key.includes('familyMember-list')) {
                                $('tr[data-entity="core_accompanyingperson"]').each(function() {
                                    $(this).find(`#${key}`).html(value);
                                });
                            } else if (key.includes('document-list')) {
                                $('tr[data-entity="core_uploadfromportal"]').each(function() {
                                    $(this).find(`#${key}`).html(value);
                                });
                            } else if (key.includes('my-account-request-list')) {
                                $('tr[data-entity="core_precase"]').each(function() {
                                    $(this).find(`#${key}`).html(value);
                                });
                            } else if (key.includes('my-account-info')) {
                                $('tr[data-entity="contact"]').each(function() {
                                    $(this).find(`#${key}`).html(value);
                                });
                            } else if (key.includes('option_core_typeofdocument')) {
                                keyValue = key.split('option_')[1];
                                if (keyValue) {
                                    $(`label[for="${keyValue}"]`).text(value);
                                }
                            } else if (key.includes('country_option')) {
                                keyValue = key.split('_')[2];
                                if (keyValue) {
                                    optionSelectors.slice(4).forEach(selector => {
                                        $(`#${selector} option[data-country="${keyValue}"]`).text(value);
                                    });
                                    [`#core_nationalityid_name[value="${keyValue}"]`, 
                                     `#core_portalcountry_name[value="${keyValue}"]`]
                                    .forEach(selector => {
                                        $(selector).val(value);
                                    });
                                }
                            } else if (key.includes('form_step_button')) {
                                const activeStep = parseInt($('li.list-group-item.active .number').html(), 10);
                                const previousStep = activeStep - 1;
                                const nextStep = activeStep + 1;
                                if($('#NextButton').val() != "SUBMIT MY REQUEST") $('#NextButton').val(`${value} ${nextStep}`);
                                if (previousStep > 0) {
                                    $('#PreviousButton').val(`${value} ${previousStep}`);
                                }
                            } else if (key.includes('Data_Protection_Video')) {
                                videoIframe = document.getElementById('Data_Protection_Video');
                                if (videoIframe) videoIframe.src = value;
                            } else if (key.includes('How_It_Works_Video')) {
                                videoIframe = document.getElementById('How_It_Works_Video');
                                if (videoIframe) videoIframe.src = value;
                            } else {
                                $(`#${key}`).html(value);
                            }
                        });
                    });
        
                    const specificString = "[Sought Person's Full name]";
                    const container = document.body;
                    const matchingElements = IcrcHelper.Common.findLeafNodesWithText(container, specificString);
        
                    matchingElements.forEach(element => {
                        const text = $(element).text().replace(specificString, soughtPersonName);
                        $(element).text(text);
                    });
        
                    $("a").attr('href', function(i, h) {
                        if (!h.includes('https://')) {
                            return h + (h.indexOf('?') !== -1 ? "&lang=" + localStorage.getItem('lang') : "?lang=" + localStorage.getItem('lang'));
                        }
                    });
        
                    $('#loader-container').hide();
                    $('body').show();
                },
                error: function (xhr, textStatus, errorThrown) {
                    console.log(xhr);
                }
            });
        }
        Common.restructureTable = function(context){
            var parentTrs = context.querySelectorAll('[data-entity="core_accompanyingperson"]');
             parentTrs.forEach(function(parentTr){
                var newTr = document.createElement('tr');
                var index = 0;
        
                var childTrs = parentTr.querySelectorAll('tr');
                childTrs.forEach(function(childTr) {
                    var thElements = childTr.querySelectorAll('th');
                    var tdElements = childTr.querySelectorAll('td');
        
                    thElements.forEach(function(th) {
                        var clonedTh = th.cloneNode(true);
                        newTr.appendChild(clonedTh);
                    });
        
                    for (var i = 0; i < tdElements.length; i++) {
                        var clonedTd = tdElements[i].cloneNode(true);
                        newTr.appendChild(clonedTd);
                        index++;
                        if (index % (thElements.length + 1) === 0) {
                            parentTr.appendChild(newTr);
                            newTr = document.createElement('tr');
                        }
                    }
                });
        
                parentTr.appendChild(parentTr.querySelector("td[aria-label='action menu']"));
        
                childTrs.forEach(function(childTr) {
                    parentTr.removeChild(childTr);
                });
            })
        }
        Common.transposeTable = function(context, isDocumentList){
            const table = context;
            const tableHead = table.querySelector('thead');
            const headerRow = table.querySelector('thead tr');
            const dataRows = table.querySelectorAll('tbody tr');
        
            dataRows.forEach(function(dataRow) {
                dataRow.querySelectorAll('td').forEach(function(cell, index) {
                    const headerCell = headerRow.querySelectorAll('th')[index].cloneNode(true);
        
                    const newRow = document.createElement('tr');
                    
                    if(cell.getAttribute('aria-label').includes('action menu')){
                        const editLink = cell.querySelector('.edit-link');
                        const deleteLink = cell.querySelector('.delete-link');
                        const detailsLink = cell.querySelector('.details-link');
                        const relatedRecordLink = cell.querySelector('.create-related-record-link')
        
                        cell.innerHTML = '';
        
                        if (editLink) cell.appendChild(editLink);
                        if (deleteLink) cell.appendChild(deleteLink);
                        if (detailsLink && !isDocumentList) cell.appendChild(detailsLink);
                        if (relatedRecordLink) cell.appendChild(relatedRecordLink);
                    }else{
                        if(isDocumentList){
                            headerCell.setAttribute('colspan', '2');
                            cell.setAttribute('colspan', '2');
                        }
                        newRow.appendChild(headerCell);
                        newRow.appendChild(cell.cloneNode(true));
        
                        const parent = cell.parentNode;
                        parent.insertBefore(newRow, cell);
                        parent.removeChild(cell);
                    }
                });
            });
            
            if(tableHead){
               tableHead.style.display = 'none'; 
            }  
            
            if(!isDocumentList){
                var isDesktop = window.matchMedia("(min-width: 550px)");
                if(isDesktop.matches){
                    IcrcHelper.Common.restructureTable(context);
                }
            }
        }
        Common.subgridLoad = function(isDocumentList){
            $(".entity-grid.subgrid").on("loaded", function () {
                $('#loader-container').show();
                $('body').hide();
                $(this).find('.grid-actions .create-action').removeClass('btn-primary').addClass('btn-default').css('border', '2px solid');
                $(this).find('.grid-actions').find('.pull-right, .pull-left').removeClass('pull-right pull-left');
                if($(this).find('tbody tr').length <= 0){
                    $(this).find('thead').hide();
                    $(this).find('.view-pagination').after($('.grid-actions'));
                    $('#loader-container').hide();
                    $('body').show();
                }else{
                    $(this).find('thead').show();
                    var tableColumns = $(this).find("table thead th a");
                    tableColumns.each(function(){
                        $(this).find("span.sort-hint, span.fa-arrow-down").remove();
                        var columnName = $(this).find('span');
                        $(columnName).addClass('table-column-name');
                        $(this).replaceWith(columnName);
                    })
                    if(isDocumentList){
                        $(this).find("table tbody tr[data-entity='core_uploadfromportal']").each(function(){
                            var firstColumn = $(this).find("td a").eq(0);
                            var firstColumnText = $(firstColumn).text();
                            firstColumn.replaceWith(firstColumnText);

                            IcrcHelper.Data.getFileName($(this).data('id'), $(this));
                        })
                    }
                    $(this).after($('.grid-actions'));
                    IcrcHelper.Common.translateElements(localStorage.getItem('lang'), localStorage.getItem('soughtPersonName'));
                    IcrcHelper.Common.transposeTable(this, isDocumentList);
                }
            });
        }
        return Common;
    }());
    IcrcHelper.Common = Common;
    var Data = /** @class */ (function () {
        function Data() {
        }
        Data.getCountryList = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, $.ajax({
                            async: true,
                            type: 'GET',
                            contentType: 'application/json; charset=utf-8',
                            dataType: 'json',
                            url: '~/_api/core_defaultvalueses?$select=core_name&$expand=core_core_defaultvalues_core_country($select=core_name, core_countryid)',
                            beforeSend: function (xhr) {
                                xhr.setRequestHeader('Accept', 'application/json');
                            },
                            error: function (xhr, textStatus, errorThrown) {
                                console.log(textStatus + ' ' + errorThrown);
                            }
                        })];
                });
            });
        };
        Data.getUploadIdOnlyList = function (filter) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, $.ajax({
                            async: true,
                            type: 'GET',
                            contentType: 'application/json; charset=utf-8',
                            dataType: 'json',
                            url: '~/_api/core_uploadfromportals?$select=_regardingobjectid_value,core_typeofdocument&$filter=' + filter,
                            beforeSend: function (xhr) {
                                xhr.setRequestHeader('Accept', 'application/json');
                            },
                            error: function (xhr, textStatus, errorThrown) {
                                console.log(textStatus + ' ' + errorThrown);
                            }
                        })];
                });
            });
        };
        Data.getFileName = function (filter, element) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, $.ajax({
                            async: true,
                            type: 'GET',
                            contentType: 'application/json; charset=utf-8',
                            dataType: 'json',
                            url: `~/_api/annotations?$select=filename&$filter=_objectid_value eq ${filter}`,
                            headers: {
                                "Prefer": "odata.include-annotations=*"
                            },
                            beforeSend: function (xhr) {
                                xhr.setRequestHeader('Accept', 'application/json');
                            },
                            success: function (res){
                                const fileName = res.value[0].filename;
                                $(element).prepend(`<tr><th style="${$('tr[data-entity="core_uploadfromportal"] th.sort-enabled').eq(0).attr('style')}"><span id="document-list-fileName" class="table-column-name">Filename</span></th><td>${fileName}</td></tr>`);
                            },
                            error: function (xhr, textStatus, errorThrown) {
                                console.log(textStatus + ' ' + errorThrown);
                            }
                        })];
                });
            });
        };
        return Data;
    }());
    IcrcHelper.Data = Data;
    var Plugins = /** @class */ (function () {
        function Plugins() {
        }
        Plugins.getCountriesSomaliaEthiopia = function () {
            return __awaiter(this, void 0, void 0, function () {
                var filter;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            return [4 /*yield*/, IcrcHelper.Data.getCountryList()];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        Plugins.setVisibleKinship = function (somaliaAndEthiopia, fieldNationality, tabKinship) {
            var nationalityId = $("#" + fieldNationality).val();
            IcrcHelper.Common.setSectionVisible(tabKinship, false);
            somaliaAndEthiopia.value[0].core_core_defaultvalues_core_country.forEach(function (country) {
                if (country && country.core_countryid && country.core_countryid === nationalityId) {
                    IcrcHelper.Common.setSectionVisible(tabKinship, true);
                }
            });
        };
        return Plugins;
    }());
    IcrcHelper.Plugins = Plugins;
    var Validator = /** @class */ (function () {
        function Validator() {
        }
        Validator.isPageValid = function () {
            if (typeof (Page_Validators) === 'undefined'
                || typeof (Page_ClientValidate) !== 'function') {
                return;
            }
            Page_ClientValidate();
            return Page_Validators.find(function (validator) { return !validator.isvalid; }) === undefined;
        };
        Validator.addRequiredFieldValidator = function (fieldName, fieldLabel) {
            if (typeof (Page_Validators) == 'undefined') {
                return;
            }
            var validatorId = "RequiredFieldValidator" + fieldName;
            if (Page_Validators.find(function (validator) { return validator.id === validatorId; })) {
                return;
            }
            // Create new validator
            $("#" + fieldName + "_label").parent().addClass("required");
            var newValidator = document.createElement('span');
            newValidator.style.display = "none";
            newValidator.id = "RequiredFieldValidator" + fieldName;
            newValidator.controltovalidate = "casetypecode";
            newValidator.errormessage = "<a href='#" + fieldName + "_label'>" + fieldLabel + " is a mandatory field.</a>";
            newValidator.validationGroup = "";
            newValidator.initialvalue = "";
            newValidator.evaluationfunction = function () {
                var value = $("#" + fieldName).val();
                if (value == null || value == "") {
                    return false;
                }
                else {
                    return true;
                }
            };
            // Add the new validator to the page validators array:
            Page_Validators.push(newValidator);
            // Wire-up the click event handler of the validation summary link
            $("a[href='#" + fieldName + "_label']").on("click", function () { scrollToAndFocus(fieldName + "_label", fieldName); });
        };
        Validator.removeRequiredFieldValidator = function (fieldName) {
            if (typeof (Page_Validators) == 'undefined') {
                return;
            }
            $.each(Page_Validators, function (index, validator) {
                if (validator
                    && validator.id == "RequiredFieldValidator" + fieldName) {
                    Page_Validators.splice(index, 1);
                }
            });
            $("#" + fieldName + "_label").parent().removeClass("required");
        };
        Validator.removeAllRequiredFieldValidator = function () {
            if (typeof (Page_Validators) == 'undefined') {
                return;
            }
            Page_Validators = [];
        };
        Validator.setFieldRequired = function (fieldName, fieldLable, isRequired) {
            if (isRequired) {
                this.addRequiredFieldValidator(fieldName, fieldLable);
            }
            else {
                this.removeRequiredFieldValidator(fieldName);
            }
        };
        return Validator;
    }());
    IcrcHelper.Validator = Validator;
})(IcrcHelper || (IcrcHelper = {}));

//Webapi function
(function(webapi, $){
    function safeAjax(ajaxOptions) {
    var deferredAjax = $.Deferred();

    shell.getTokenDeferred().done(function (token) {
        // add headers for AJAX
        if (!ajaxOptions.headers) {
        $.extend(ajaxOptions, {
            headers: {
            "__RequestVerificationToken": token
            }
        }); 
        } else {
        ajaxOptions.headers["__RequestVerificationToken"] = token;
        }
        $.ajax(ajaxOptions)
        .done(function(data, textStatus, jqXHR) {
            validateLoginSession(data, textStatus, jqXHR, deferredAjax.resolve);
        }).fail(deferredAjax.reject); //AJAX
    }).fail(function () {
        deferredAjax.rejectWith(this, arguments); // on token failure pass the token AJAX and args
    });

    return deferredAjax.promise();	
    }
    webapi.safeAjax = safeAjax;
})(window.webapi = window.webapi || {}, jQuery)
